/*! (C) Copyright 2020 LanguageTooler GmbH. All rights reserved. */
var __decorate=this&&this.__decorate||function(e,t,s,n){var r,i=arguments.length,a=i<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,s):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(e,t,s,n);else for(var c=e.length-1;c>=0;c--)(r=e[c])&&(a=(i<3?r(a):i>3?r(t,s,a):r(t,s))||a);return i>3&&a&&Object.defineProperty(t,s,a),a};class CEElementInspector{constructor(e,t,s=!0){if(this._ceElement=e,this._parsingDetector=t,this._enableCache=s,this._cachedNodes=new Set,this._nodePropertiesCache={isTextNode:new Map,isElementNode:new Map,computedStyle:new Map,isSkippingElement:new Map,replacementText:new Map,isBr:new Map,isBlock:new Map,parsingOptions:new Map,parsedText:new Map,blockParent:new Map,paragraphLastValuableNode:new Map,isBRElementRelevant:new Map,isBlockElementRelevant:new Map,isTextEndsWithLineBreak:new Map,isParagraphNonEmpty:new Map},this._enableCache){this._onCEElementChange=this._onCEElementChange.bind(this),this._ceElementObserver=this._parsingDetector.createMutationObserver(this._onCEElementChange);const e={attributes:!0,attributeOldValue:!0,characterData:!0,characterDataOldValue:!1,childList:!0,subtree:!0};this._ceElementObserver.observe(this._ceElement,e)}}static _replaceLineBreaks(e){return e.replace(CEElementInspector.LINE_BREAKS_REGEXP," ")}static _joinWhitespaces(e){return e.replace(CEElementInspector.WHITESPACE_REGEXP," ")}static _isBlankString(e){return!e.trim()}static cached(e){return CEElementInspector._cacheInvalidationRules.push(e),function(t,s,n){const r=n.value;return n.value=function(t){if(this._enableCache){if(!this._nodePropertiesCache[e.key].has(t)){this._cachedNodes.add(t);const s=r.call(this,t);return this._nodePropertiesCache[e.key].set(t,s),s}return this._nodePropertiesCache[e.key].get(t)}return r.call(this,t)},n}}_deleteCacheForNode(e,t=!0){const s=this.isTextNode(e);this._cachedNodes.delete(e);for(const t in this._nodePropertiesCache)this._nodePropertiesCache[t].delete(e);if(t&&!s){const t=DOMWalker.create(e);for(;t.next();){this._cachedNodes.delete(t.currentNode);for(const e in this._nodePropertiesCache)this._nodePropertiesCache[e].delete(t.currentNode)}}}isWhiteSpace(e){return this._parsingDetector.isWhiteSpace(e)}_normalizeMutations(e){const t={};e.forEach((e=>{"attributes"===e.type&&e.attributeName&&(t[e.attributeName]=t[e.attributeName]||[],t[e.attributeName].push(e))}));for(const s in t)if(t.hasOwnProperty(s)){const n=t[s];if(n.length<2)continue;const r=n[0];r.oldValue===r.target.getAttribute(s)&&n.forEach((t=>{e.splice(e.indexOf(t),1)}))}}_checkRuleConditions(e,t){if(!e)return!1;switch(t.type){case"attributes":return!!e.attributes&&(0===e.attributes.length||e.attributes.includes(t.attributeName));case"characterData":return!!e.characterData;case"childList":return!!e.childList}return!1}_onCEElementChange(e){this._normalizeMutations(e),this._cachedNodes.forEach((e=>{this._ceElement.contains(e)||this._deleteCacheForNode(e)}));for(const t of e){const e=t.target;if(!this._ceElement.contains(e))continue;"childList"===t.type&&t.removedNodes.forEach((e=>this._deleteCacheForNode(e)));const s=this.getBlockParent(e),n=e!==s;for(const r of CEElementInspector._cacheInvalidationRules){if(this._checkRuleConditions(r.self,t)&&this._nodePropertiesCache[r.key].delete(e),this._checkRuleConditions(r.parent,t)){const t=DOMWalker.create(e);for(;t.next();)this._nodePropertiesCache[r.key].delete(t.currentNode)}if(n&&this._checkRuleConditions(r.blockChild,t)&&this._nodePropertiesCache[r.key].delete(s),this._checkRuleConditions(r.blockSibling,t)){const e=DOMWalker.create(s);for(;e.next();)this._nodePropertiesCache[r.key].delete(e.currentNode)}this._checkRuleConditions(r.any,t)&&this._nodePropertiesCache[r.key].clear()}}}getComputedStyle(e){return window.getComputedStyle(e)}isTextNode(e){return isTextNode(e)}isElementNode(e){return isElementNode(e)}isSkippingElement(e){return this._ceElement!==e&&(this._parsingDetector.isIgnored(e,this.getComputedStyle(e))||this._parsingDetector.isQuote(e)||this._parsingDetector.isSignature(e))}getReplacementText(e){const t=this.getComputedStyle(e),s=this._parsingDetector.isIgnored(e,t);return this._parsingDetector.getReplacementText(e,s,t)}isBr(e){return"BR"===e.tagName}isBlock(e){return this._parsingDetector.isBlock(e,this.getComputedStyle(e))}getParsingOptions(e){const t=this.isElementNode(e)?e:e.parentNode;if(this._parsingDetector.getParsingOptions)return this._parsingDetector.getParsingOptions(t);const s=this.getComputedStyle(t).whiteSpace||"";return{element:t,preserveLineBreaks:CEElementInspector.PRESERVE_LINEBREAKS_VALUES.includes(s),preserveWhitespaces:CEElementInspector.PRESERVE_WHITESPACES_VALUES.includes(s)}}getParsedText(e){const t=this.getParsingOptions(e);let s=e.nodeValue;return t.preserveLineBreaks||(s=CEElementInspector._replaceLineBreaks(s)),s=this._parsingDetector.replaceText(s,e,t.element),t.preserveWhitespaces||(s=CEElementInspector._joinWhitespaces(s)),s}getBlockParent(e){let t=this.isElementNode(e)?e:e.parentElement;for(;t!==this._ceElement&&!this.isBlock(t);)t=t.parentElement;return t}getParagraphLastValuableNode(e){const t=this.getBlockParent(e),s=DOMWalker.create(t,e);let n=!1,r=null;do{const e=s.currentNode;if(n=!1,this.isElementNode(e))if(this.getReplacementText(e)&&(r=e),this.isSkippingElement(e))n=!0;else{if(this.isBlock(e))return r;if(this.isBr(e))return r}else if(this.isTextNode(e)){const t=this.getParsingOptions(e),s=this.getParsedText(e);(t.preserveWhitespaces&&s||!CEElementInspector.BLANK_STRING_REGEXP.test(s))&&(r=e)}}while(s.next(n));return r}isBRElementRelevant(e){const t=this.getBlockParent(e);let s=DOMWalker.create(t),n=!1,r=!1;for(;s.next(n);){const t=s.currentNode;if(n=!1,this.isElementNode(t)){if(t===e)break;this.getReplacementText(t)&&(r=!0),this.isSkippingElement(t)?n=!0:this.isBlock(t)&&(r=!1,n=!0)}else if(this.isTextNode(t)){const e=this.getParsingOptions(t),s=this.getParsedText(t);(e.preserveWhitespaces&&s||!CEElementInspector._isBlankString(s))&&(r=!0)}}for(s=DOMWalker.create(t,e),n=!1;s.next(n);){const e=s.currentNode;if(n=!1,this.isElementNode(e)){if(this.getReplacementText(e))return!0;if(this.isSkippingElement(e))n=!0;else{if(this.isBr(e))return!0;if(r&&this.isBlock(e))return!1}}else if(this.isTextNode(e)){const t=this.getParsingOptions(e),s=this.getParsedText(e);if(t.preserveWhitespaces&&s||!CEElementInspector._isBlankString(s))return!0}}return!r}isBlockElementRelevant(e){return!!this._parsingDetector.isBlockElementRelevant&&this._parsingDetector.isBlockElementRelevant(e)}isTextEndsWithLineBreak(e){const t=DOMWalker.create(this._ceElement,e);let s=!!isElementNode(e)&&this.isSkippingElement(e),n=!1;for(;t.next(s);){const r=t.currentNode;if(s=!1,this.isElementNode(r)){if(this.getReplacementText(r)){const t=this.getBlockParent(e);return!contains(t,r)}if(this.isSkippingElement(r))s=!0;else if(this.isBlock(r)){if(this.isParagraphNonEmpty(r))return!0;n=!0}}else if(this.isTextNode(r)){const t=this.getParsingOptions(r),s=this.getParsedText(r);if(t.preserveWhitespaces&&s||!CEElementInspector._isBlankString(s)){if(n)return!0;{const t=this.getBlockParent(e);return!contains(t,r)}}}}return!1}isParagraphNonEmpty(e){const t=DOMWalker.create(e);let s=!1;for(;t.next(s);){const e=t.currentNode;if(s=!1,this.isElementNode(e)){if(this.getReplacementText(e))return!0;if(this.isSkippingElement(e))s=!0;else if(this.isBlock(e))return!1}else if(this.isTextNode(e)){const t=this.getParsingOptions(e),s=this.getParsedText(e);if(t.preserveWhitespaces&&s||!CEElementInspector._isBlankString(s))return!0}}return!1}destroy(){this._ceElementObserver&&this._ceElementObserver.disconnect(),this._cachedNodes.clear();for(const e in this._nodePropertiesCache)this._nodePropertiesCache[e].clear()}}CEElementInspector.DISPLAY_BLOCK_VALUES=["block","list-item","table","table-caption","table-row","table-cell","flex","grid"],CEElementInspector.SKIPPING_TAGS=["CODE","NOSCRIPT","OBJECT","SCRIPT","STYLE","TEMPLATE","VAR","CANVAS","IMG","SVG"],CEElementInspector.SUP_REGEXP=/^[\[\(]?\d+[\]\)]?/,CEElementInspector.PRESERVE_LINEBREAKS_VALUES=["pre","pre-wrap","pre-line"],CEElementInspector.PRESERVE_WHITESPACES_VALUES=["pre","pre-wrap"],CEElementInspector._cacheInvalidationRules=[],CEElementInspector.LINE_BREAKS_REGEXP=/\n/g,CEElementInspector.BLANK_STRING_REGEXP=/^[ \uFEFF]*$/,CEElementInspector.WHITESPACE_REGEXP=/  +/g,__decorate([CEElementInspector.cached({key:"computedStyle"})],CEElementInspector.prototype,"getComputedStyle",null),__decorate([CEElementInspector.cached({key:"isTextNode"})],CEElementInspector.prototype,"isTextNode",null),__decorate([CEElementInspector.cached({key:"isElementNode"})],CEElementInspector.prototype,"isElementNode",null),__decorate([CEElementInspector.cached({key:"isSkippingElement",any:{attributes:[],characterData:!0,childList:!0}})],CEElementInspector.prototype,"isSkippingElement",null),__decorate([CEElementInspector.cached({key:"replacementText",self:{attributes:[],characterData:!0,childList:!0},parent:{attributes:[],characterData:!0,childList:!0}})],CEElementInspector.prototype,"getReplacementText",null),__decorate([CEElementInspector.cached({key:"isBr"})],CEElementInspector.prototype,"isBr",null),__decorate([CEElementInspector.cached({key:"isBlock",self:{attributes:["id","class","style"]},parent:{attributes:["id","class","style"]}})],CEElementInspector.prototype,"isBlock",null),__decorate([CEElementInspector.cached({key:"parsingOptions",self:{attributes:["id","class","style"]},parent:{attributes:["id","class","style"]}})],CEElementInspector.prototype,"getParsingOptions",null),__decorate([CEElementInspector.cached({key:"parsedText",self:{characterData:!0},parent:{attributes:["id","class","style"]}})],CEElementInspector.prototype,"getParsedText",null),__decorate([CEElementInspector.cached({key:"blockParent",self:{attributes:["id","class","style"]},parent:{attributes:["id","class","style"]}})],CEElementInspector.prototype,"getBlockParent",null),__decorate([CEElementInspector.cached({key:"paragraphLastValuableNode",parent:{attributes:["id","class","style"]},blockSibling:{attributes:["id","class","style"],characterData:!0,childList:!0}})],CEElementInspector.prototype,"getParagraphLastValuableNode",null),__decorate([CEElementInspector.cached({key:"isBRElementRelevant",any:{attributes:[],characterData:!0,childList:!0}})],CEElementInspector.prototype,"isBRElementRelevant",null),__decorate([CEElementInspector.cached({key:"isBlockElementRelevant",any:{attributes:[],characterData:!0,childList:!0}})],CEElementInspector.prototype,"isBlockElementRelevant",null),__decorate([CEElementInspector.cached({key:"isTextEndsWithLineBreak",any:{attributes:[],characterData:!0,childList:!0}})],CEElementInspector.prototype,"isTextEndsWithLineBreak",null),__decorate([CEElementInspector.cached({key:"isParagraphNonEmpty",parent:{attributes:["id","class","style"]},blockChild:{attributes:[],characterData:!0,childList:!0}})],CEElementInspector.prototype,"isParagraphNonEmpty",null);